<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>Transform to ballot-date-level observations — as_ballot_dates • rdb</title><script src="../lightswitch.js"></script><script src="../deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="../deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="../deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="../deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="../deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="../deps/headroom-0.11.0/headroom.min.js"></script><script src="../deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="../deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="../deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="../deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="../deps/search-1.0.0/fuse.min.js"></script><script src="../deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="../pkgdown.js"></script><meta property="og:title" content="Transform to ballot-date-level observations — as_ballot_dates"><meta name="description" content="Transforms referendum-level observations to ones on the level of ballot date and jurisdiction via nesting of referendum-level columns. The
individual values of all the referendums on a specific ballot date in a specific jurisdiction are preserved in a list column named rfrnd_data."><meta property="og:description" content="Transforms referendum-level observations to ones on the level of ballot date and jurisdiction via nesting of referendum-level columns. The
individual values of all the referendums on a specific ballot date in a specific jurisdiction are preserved in a list column named rfrnd_data."><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="../index.html">rdb</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9046</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="nav-item"><a class="nav-link" href="../articles/rdb.html">Get started</a></li>
<li class="active nav-item"><a class="nav-link" href="../reference/index.html">Reference</a></li>
<li class="nav-item"><a class="nav-link" href="../articles/codebook.html">RDB codebook</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="../search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/zdaarau/rpkgs/rdb/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-reference-topic">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>Transform to ballot-date-level observations</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/zdaarau/rpkgs/rdb/blob/HEAD/R/rdb.gen.R" class="external-link"><code>R/rdb.gen.R</code></a></small>
      <div class="d-none name"><code>as_ballot_dates.Rd</code></div>
    </div>

    <div class="ref-description section level2">
    <p>Transforms referendum-level observations to ones on the level of ballot date and jurisdiction via <a href="https://tidyr.tidyverse.org/reference/nest.html" class="external-link">nesting</a> of referendum-level columns. The
individual values of all the referendums on a specific ballot date in a specific jurisdiction are preserved in a list column named <code>rfrnd_data</code>.</p>
    </div>

    <div class="section level2">
    <h2 id="ref-usage">Usage<a class="anchor" aria-label="anchor" href="#ref-usage"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span><span class="fu">as_ballot_dates</span><span class="op">(</span><span class="va">data</span>, cols_to_retain <span class="op">=</span> <span class="cn">NULL</span><span class="op">)</span></span></code></pre></div>
    </div>

    <div class="section level2">
    <h2 id="arguments">Arguments<a class="anchor" aria-label="anchor" href="#arguments"></a></h2>


<dl><dt id="arg-data">data<a class="anchor" aria-label="anchor" href="#arg-data"></a></dt>
<dd><p>RDB referendum data as returned by <code><a href="rfrnds.html">rfrnds()</a></code>. A data frame that at minimum contains the column <code>date</code>.</p></dd>


<dt id="arg-cols-to-retain">cols_to_retain<a class="anchor" aria-label="anchor" href="#arg-cols-to-retain"></a></dt>
<dd><p>Additional non-standard columns to be preserved as top-level columns instead of being nested in the list column <code>rfrnd_data</code>. They
mustn't vary within ballot-date-level observations. <a href="https://dplyr.tidyverse.org/reference/dplyr_tidy_select.html" class="external-link">Tidy selections</a> are supported.</p></dd>

</dl></div>
    <div class="section level2">
    <h2 id="value">Value<a class="anchor" aria-label="anchor" href="#value"></a></h2>
    <p>A <a href="https://tibble.tidyverse.org/reference/tbl_df-class.html" class="external-link">tibble</a>.</p>
    </div>
    <div class="section level2">
    <h2 id="see-also">See also<a class="anchor" aria-label="anchor" href="#see-also"></a></h2>
    <div class="dont-index"><p>Other referendum data transformation functions:
<code><a href="n_rfrnds.html">n_rfrnds</a>()</code>,
<code><a href="n_rfrnds_per_period.html">n_rfrnds_per_period</a>()</code>,
<code><a href="prettify_col_names.html">prettify_col_names</a>()</code>,
<code><a href="unnest_var.html">unnest_var</a>()</code></p></div>
    </div>

    <div class="section level2">
    <h2 id="ref-examples">Examples<a class="anchor" aria-label="anchor" href="#ref-examples"></a></h2>
    <div class="sourceCode"><pre class="sourceCode r"><code><span class="r-in"><span><span class="co"># standard RDB columns are retained as far as possible</span></span></span>
<span class="r-in"><span><span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="rfrnds.html">rfrnds</a></span><span class="op">(</span>quiet <span class="op">=</span> <span class="cn">TRUE</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>  <span class="fu">rdb</span><span class="fu">::</span><span class="fu">as_ballot_dates</span><span class="op">(</span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #949494;"># A tibble: 5,939 × 8</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span>    country_code country_name  subnational_entity_name municipality level       date       is_former_country rfrnd_data       </span>
<span class="r-out co"><span class="r-pr">#&gt;</span>    <span style="color: #949494; font-style: italic;">&lt;fct&gt;</span>        <span style="color: #949494; font-style: italic;">&lt;fct&gt;</span>         <span style="color: #949494; font-style: italic;">&lt;chr&gt;</span>                   <span style="color: #949494; font-style: italic;">&lt;chr&gt;</span>        <span style="color: #949494; font-style: italic;">&lt;ord&gt;</span>       <span style="color: #949494; font-style: italic;">&lt;date&gt;</span>     <span style="color: #949494; font-style: italic;">&lt;lgl&gt;</span>             <span style="color: #949494; font-style: italic;">&lt;list&gt;</span>           </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 1</span> CH           Switzerland   Zug                     <span style="color: #BB0000;">NA</span>           subnational 2024-06-09 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 2</span> LI           Liechtenstein <span style="color: #BB0000;">NA</span>                      <span style="color: #BB0000;">NA</span>           national    2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 3</span> CH           Switzerland   Jura                    <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 4</span> CH           Switzerland   Uri                     <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [2 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 5</span> CH           Switzerland   Nidwalden               <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [2 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 6</span> CH           Switzerland   Bern                    <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [2 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 7</span> CH           Switzerland   Basel Landschaft        <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 8</span> CH           Switzerland   Graubünden              <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;"> 9</span> CH           Switzerland   Schwyz                  <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [1 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #BCBCBC;">10</span> CH           Switzerland   Solothurn               <span style="color: #BB0000;">NA</span>           subnational 2024-09-22 <span style="color: #BB0000;">NA</span>                <span style="color: #949494;">&lt;tibble [2 × 60]&gt;</span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> <span style="color: #949494;"># ℹ 5,929 more rows</span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># non-standard columns must be explicitly specified in order to be retained</span></span></span>
<span class="r-in"><span><span class="va">data_rdb</span> <span class="op">&lt;-</span></span></span>
<span class="r-in"><span>  <span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="rfrnds.html">rfrnds</a></span><span class="op">(</span>quiet <span class="op">=</span> <span class="cn">TRUE</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>    <span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="add_world_regions.html">add_world_regions</a></span><span class="op">(</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>    <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/mutate.html" class="external-link">mutate</a></span><span class="op">(</span>region_custom <span class="op">=</span></span></span>
<span class="r-in"><span>                    <span class="fu"><a href="https://rdrr.io/r/base/factor.html" class="external-link">factor</a></span><span class="op">(</span>x <span class="op">=</span> <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/if_else.html" class="external-link">if_else</a></span><span class="op">(</span><span class="va">country_code</span> <span class="op">==</span> <span class="st">"CH"</span>,</span></span>
<span class="r-in"><span>                                              <span class="st">"Switzerland &amp; Liechtenstein"</span>,</span></span>
<span class="r-in"><span>                                              <span class="va">un_region_tier_1_name</span><span class="op">)</span>,</span></span>
<span class="r-in"><span>                           levels <span class="op">=</span> <span class="fu"><a href="https://rdrr.io/r/base/c.html" class="external-link">c</a></span><span class="op">(</span><span class="st">"Switzerland &amp; Liechtenstein"</span>,</span></span>
<span class="r-in"><span>                                      <span class="fu"><a href="https://rdrr.io/r/base/levels.html" class="external-link">levels</a></span><span class="op">(</span><span class="va">un_region_tier_1_name</span><span class="op">)</span><span class="op">)</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>                    <span class="fu">forcats</span><span class="fu">::</span><span class="fu"><a href="https://forcats.tidyverse.org/reference/fct_relevel.html" class="external-link">fct_relevel</a></span><span class="op">(</span><span class="st">"Switzerland &amp; Liechtenstein"</span>,</span></span>
<span class="r-in"><span>                                         after <span class="op">=</span> <span class="fl">3L</span><span class="op">)</span> <span class="op">|&gt;</span></span></span>
<span class="r-in"><span>                    <span class="fu">forcats</span><span class="fu">::</span><span class="fu"><a href="https://forcats.tidyverse.org/reference/fct_recode.html" class="external-link">fct_recode</a></span><span class="op">(</span><span class="st">"rest of Europe"</span> <span class="op">=</span> <span class="st">"Europe"</span><span class="op">)</span><span class="op">)</span></span></span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="va">data_rdb</span> <span class="op">|&gt;</span> <span class="fu">rdb</span><span class="fu">::</span><span class="fu">as_ballot_dates</span><span class="op">(</span><span class="op">)</span> <span class="op">|&gt;</span> <span class="fu"><a href="https://rdrr.io/r/base/colnames.html" class="external-link">colnames</a></span><span class="op">(</span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span>  [1] "country_code"            "country_name"            "subnational_entity_name" "municipality"            "un_country_code"         "un_region_tier_1_code"  </span>
<span class="r-out co"><span class="r-pr">#&gt;</span>  [7] "un_region_tier_1_name"   "un_region_tier_2_code"   "un_region_tier_2_name"   "un_region_tier_3_code"   "un_region_tier_3_name"   "un_subregion"           </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [13] "level"                   "date"                    "is_former_country"       "rfrnd_data"             </span>
<span class="r-in"><span><span class="va">data_rdb</span> <span class="op">|&gt;</span> <span class="fu">rdb</span><span class="fu">::</span><span class="fu">as_ballot_dates</span><span class="op">(</span>cols_to_retain <span class="op">=</span> <span class="va">region_custom</span><span class="op">)</span> <span class="op">|&gt;</span> <span class="fu"><a href="https://rdrr.io/r/base/colnames.html" class="external-link">colnames</a></span><span class="op">(</span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span>  [1] "country_code"            "country_name"            "subnational_entity_name" "municipality"            "un_country_code"         "un_region_tier_1_code"  </span>
<span class="r-out co"><span class="r-pr">#&gt;</span>  [7] "un_region_tier_1_name"   "un_region_tier_2_code"   "un_region_tier_2_name"   "un_region_tier_3_code"   "un_region_tier_3_name"   "un_subregion"           </span>
<span class="r-out co"><span class="r-pr">#&gt;</span> [13] "level"                   "date"                    "is_former_country"       "region_custom"           "rfrnd_data"             </span>
<span class="r-in"><span></span></span>
<span class="r-in"><span><span class="co"># non-standard columns to retain must actually be retainable</span></span></span>
<span class="r-in"><span><span class="kw"><a href="https://rdrr.io/r/base/try.html" class="external-link">try</a></span><span class="op">(</span></span></span>
<span class="r-in"><span>  <span class="va">data_rdb</span> <span class="op">|&gt;</span> <span class="fu">rdb</span><span class="fu">::</span><span class="fu">as_ballot_dates</span><span class="op">(</span>cols_to_retain <span class="op">=</span> <span class="va">title_en</span><span class="op">)</span></span></span>
<span class="r-in"><span><span class="op">)</span></span></span>
<span class="r-out co"><span class="r-pr">#&gt;</span> Error in rdb::as_ballot_dates(data_rdb, cols_to_retain = title_en) : </span>
<span class="r-out co"><span class="r-pr">#&gt;</span>   Retaining the additional non-standard column `title_en` while converting to ballot-date-level observations is impossible because this column varies</span>
<span class="r-out co"><span class="r-pr">#&gt;</span> within ballot dates.</span>
</code></pre></div>
    </div>
  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann, Uwe Serdült.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer></div>





  </body></html>

